if not Watcher then return end

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local AceAddon = LibStub("AceAddon-3.0")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");



function Watcher:SetPriorityFrame(FrameName, optionnum)
		FrameName:ClearAllPoints()
		FrameName:SetFrameStrata("BACKGROUND")
		FrameName:SetWidth(Watcher.db.char.priority.IconSize)
		FrameName:SetHeight(self.db.char.priority.IconSize)
		FrameName:EnableMouse(0)
		local name = self.db.char.priority.option[optionnum]
		
		if name ~= "none" or not name then
		 FrameName.spell = self:returnSpellByName(self.db.char.priority.option[optionnum])
		else
			FrameName.spell = {}
			FrameName.spell.icon = ""
		end
		
		-- Configure Icon texture and if LBF set normal texture
		if not FrameName.texture then
			FrameName.texture = FrameName:CreateTexture(nil, "OVERLAY")
		end
		FrameName.texture:SetWidth(Watcher.db.char.priority.IconSize)
		FrameName.texture:SetHeight(self.db.char.priority.IconSize)
		FrameName.texture:SetPoint("CENTER", FrameName, "CENTER", 0, 0)
		FrameName.texture:SetTexture(FrameName.spell.icon)
		if LBF then
			if not FrameName.ntexture then
			FrameName.ntexture = FrameName:CreateTexture(nil)
			end
			local group = LBF:Group("Watcher","Watcher1")
			group:AddButton(FrameName, {Icon = FrameName.texture, Normal = FrameName.ntexture})
		end
		-- set frame level so correct frames overlap
		FrameName:SetFrameLevel((self.db.char.priority.num * 20) - ((optionnum-1)*10))


		------- Create An animation group to play different animations when spells are ready ---
		if not FrameName.animGrp then
		FrameName.animGrp = FrameName:CreateAnimationGroup("Priority"..optionnum.."AnimationGroup")
		--[[FrameName.rotL = FrameName.animGrp:CreateAnimation("Rotation")
		FrameName.rotL:SetDuration(0.1)
		FrameName.rotL:SetDegrees(10)
		FrameName.rotL:SetOrder(1)

		FrameName.rotR = FrameName.animGrp:CreateAnimation("Rotation")
		FrameName.rotR:SetDuration(0.2)
		FrameName.rotR:SetDegrees(-20)
		FrameName.rotR:SetOrder(2)
		]]
		FrameName.scaleUp = FrameName.animGrp:CreateAnimation("Scale")
		FrameName.scaleUp:SetDuration(0.1)
		FrameName.scaleUp:SetScale(1.2,1.2)
		FrameName.scaleUp:SetOrder(1)
		FrameName.scaleDown = FrameName.animGrp:CreateAnimation("Scale")
		FrameName.scaleDown:SetDuration(0.1)
		FrameName.scaleDown:SetScale(1/1.2,1/1.2)
		FrameName.scaleDown:SetOrder(2)

		--FrameName.alpha = FrameName.animGrp:CreateAnimation("Alpha")
		end

		-- Set KeyBindings
		if self.db.char.priority.keybindings ~= nil and self.db.char.priority.keybindings[optionnum - 1] ~=  nil then
		SetBindingSpell(self.db.char.priority.keybindings[optionnum - 1], Watcher.priorityTable.name[self.db.char.priority.option[optionnum]].."()")
		end
		
		-- create overlay text related to keybindings
		if not FrameName.keybind then
				FrameName.keybind = FrameName:CreateFontString(nil, "OVERLAY")
			end
			FrameName.keybind:Show()
			FrameName.keybind:ClearAllPoints()
			FrameName.keybind:SetTextColor(self.db.char.priority.keycol.r, self.db.char.priority.keycol.g, self.db.char.priority.keycol.b, self.db.char.priority.keycol.a)
			FrameName.keybind:SetFont(media:Fetch("font", self.db.char.iconfont), self.db.char.iconfontsize, self.db.char.iconfonteffect)
			FrameName.keybind:SetPoint("CENTER", FrameName, "CENTER", self.db.char.priority.keyhori, self.db.char.priority.keyvert)
			if self.db.char.priority.keybindings ~= nil then
				if self.db.char.priority.keybindings[optionnum-1] == "BUTTON4" then
					FrameName.keybind:SetText("B4")
				elseif self.db.char.priority.keybindings[optionnum-1] == "BUTTON3" then
					FrameName.keybind:SetText("B3")
				elseif self.db.char.priority.keybindings[optionnum-1] == "BUTTON5" then
					FrameName.keybind:SetText("B5")
				else
					FrameName.keybind:SetText(self.db.char.priority.keybindings[optionnum-1])
				end
			end


		--if using a key label then create
		if self.db.char.priority.showlabel then
			if not FrameName.Label then
				FrameName.Label = FrameName:CreateFontString(nil, "OVERLAY")
			end
			FrameName.Label:Show()
			FrameName.Label:ClearAllPoints()
			FrameName.Label:SetTextColor(self.db.char.priority.labelcol.r, self.db.char.priority.labelcol.g, self.db.char.priority.labelcol.b, self.db.char.priority.labelcol.a)
			FrameName.Label:SetFont(media:Fetch("font", self.db.char.iconfont), self.db.char.iconfontsize, self.db.char.iconfonteffect)
			FrameName.Label:SetPoint("CENTER", FrameName, "CENTER", self.db.char.priority.labelhori, self.db.char.priority.labelvert)
			FrameName.Label:SetText(self.db.char.priority.Label[optionnum])
		else
			if FrameName.Label then
			FrameName.Label:Hide()
			end
			end
		
		
		--- flash for cooldown when spell is complete
		FrameName.play = false
		FrameName.cdFlash = CreateFrame("Cooldown","Priority"..optionnum.."Cooldown",FrameName)
		FrameName.cdFlash:SetAllPoints(FrameName)


		-- create cooldown text
		if not FrameName.Text then
			FrameName.Text = FrameName:CreateFontString(nil, "OVERLAY")
		end
		FrameName.Text:ClearAllPoints()
		FrameName.Text:SetTextColor(1,1,1,1)
		FrameName.Text:SetFont(media:Fetch("font", self.db.char.iconfont), self.db.char.iconfontsize, self.db.char.iconfonteffect)
		if self.db.char.textpoint == "top" then
		FrameName.Text:SetPoint("TOP", FrameName, "TOP", 0, self.db.char.iconfontsize + 2)
		elseif self.db.char.textpoint == "bottom" then
		FrameName.Text:SetPoint("BOTTOM", FrameName, "BOTTOM", 0, -self.db.char.iconfontsize + 2)
		elseif self.db.char.textpoint == "center" then
		FrameName.Text:SetPoint("CENTER", FrameName, "CENTER", 0, 0)
		end
		if self.db.char.showbars then
			Watcher:SetBack(FrameName, optionnum)
		else
			if FrameName.status then
				FrameName.status:Hide()
			end
		end
		
		-- set update function
		if self.db.char.priority.option[optionnum] == "none" or self.db.char.priority.option[optionnum] == nil then
			FrameName:SetAlpha(0)
			FrameName.timeleft = -1
			FrameName.inactiveTimeleft = -1
			Watcher.timeLeft[optionnum+self.db.char.priority.num] = -1
			Watcher.timeLeft[optionnum] = -1
		else
			FrameName.spell:UpdateSpell(FrameName, optionnum)
		end
		FrameName:SetScript("OnUpdate",
			function()
					if (self.combat or not self.db.char.showcombat) then
						if self.db.char.priority.option[optionnum] ~= "none" then
							FrameName.spell:UpdateSpell(FrameName, optionnum)
						else
							FrameName:SetAlpha(0)									
							FrameName.timeleft = -1
							FrameName.inactiveTimeleft = -1
							Watcher.timeLeft[optionnum+self.db.char.priority.num] = -1
							Watcher.timeLeft[optionnum] = -1
						end
					end
			end	);

		if self.db.char.priority.iconcd then
			FrameName.Text:Show()
		else
			FrameName.Text:Hide()
		end
	end

