if not Watcher then return end

if select(2, UnitClass('player')) ~= "DEATHKNIGHT" then return end

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants
	
-- Blood Icons
Watcher:addicon("Blood Strike", 45902)
Watcher:addicon("Death Strike", 49998)
Watcher:addicon("Pestilence", 50842)
Watcher:addicon("Blood Boil", 48721)
Watcher:addicon("Strangulate", 47476)
Watcher:addicon("Blood Tap", 45529)
Watcher:addicon("Dark Command", 56222)
Watcher:addicon("Death Pact", 48743)
Watcher:addicon("Dark Simulacrum", 77606)
Watcher:addicon("Heart Strike", 55050)
Watcher:addicon("Bone Shield", 49222)
Watcher:addicon("Rune Tap", 48982)
Watcher:addicon("Vampiric Blood", 55233)
Watcher:addicon("Dancing Rune Weapon", 49028)

-- Frost Icons
Watcher:addicon("Icy Touch", 45477)
Watcher:addicon("Frost Fever", 59921)
Watcher:addicon("Mind Freeze", 47528)
Watcher:addicon("Chains of Ice", 45524)
Watcher:addicon("Obliterate", 49020)
Watcher:addicon("Path of Frost", 3714)
Watcher:addicon("Icebound Fortitude", 48792)
Watcher:addicon("Horn of Winter", 57330)
Watcher:addicon("Festering Strike", 85948)
Watcher:addicon("Rune Strike", 56815)
Watcher:addicon("Empower Rune Weapon", 47568)
Watcher:addicon("Frost Strike", 49143)
Watcher:addicon("Lichborne", 49039)
Watcher:addicon("Pillar of Frost", 51271)
Watcher:addicon("Hungering Cold", 49203)
Watcher:addicon("Howling Blast", 49184)

-- Unholy Icons
Watcher:addicon("Death Coil", 47541)
Watcher:addicon("Sudden Doom", 81340)
Watcher:addicon("Death Grip", 49576)
Watcher:addicon("Plague Strike", 45462)
Watcher:addicon("Blood Plague", 59879)
Watcher:addicon("Raise Dead", 46584)
Watcher:addicon("Death and Decay", 43265)
Watcher:addicon("Anti-Magic Shell", 48707)
Watcher:addicon("Raise Ally", 61999)
Watcher:addicon("Army of the Dead", 42650)
Watcher:addicon("Outbreak", 77575)
Watcher:addicon("Necrotic Strike", 73975)
Watcher:addicon("Scourge Strike", 55090)
Watcher:addicon("Unholy Frenzy", 49016)
Watcher:addicon("Anti-Magic Zone", 51052)
Watcher:addicon("Dark Transformation", 63560)
Watcher:addicon("Summon Gargoyle", 49206)

function Watcher:addClassSpells()
	-- Blood Spells and Talents
	Watcher:newSpell(Spell:Direct("Blood Strike"))
	Watcher:newSpell(Spell:Direct("Death Strike"))
	-- Watcher:newSpell(Spell:Capitalize(C["Blood Plague AND Frost Fever"]. "Pestilence", 30)  Can't be implimented yet, requires tracking 2 debuffs, and minimum time between casts.)
	Watcher:newSpell(Spell:Direct("Blood Boil"))
	Watcher:newSpell(Spell:Debuff("Strangulate"))
	Watcher:newSpell(Spell:Direct("Blood Tap"))
	Watcher:newSpell(Spell:Direct("Dark Command"))
	Watcher:newSpell(Spell:Direct("Death Pact"))
	Watcher:newSpell(Spell:Debuff("Dark Simulacrum"))
	Watcher:newSpell(Spell:Direct("Heart Strike"))
	Watcher:newSpell(Spell:Buff(C["Bone Shield"], "Bone Shield"))
	Watcher:newSpell(Spell:Direct("Rune Tap"))
	Watcher:newSpell(Spell:Buff(C["Vampiric Blood"], "Vampiric Blood"))
	Watcher:newSpell(Spell:Direct("Dancing Rune Weapon"))
	
	-- Frost Spells and Talents
	Watcher:newSpell(Spell:Apply(C["Frost Fever"], "Icy Touch"))
	Watcher:newSpell(Spell:Direct("Mind Freeze"))
	Watcher:newSpell(Spell:Debuff("Chains of Ice"))
	Watcher:newSpell(Spell:Direct("Obliterate"))
	Watcher:newSpell(Spell:BuffPerm("Path of Frost"))
	Watcher:newSpell(Spell:Buff(C["Icebound Fortitude"], "Icebound Fortitude"))
	Watcher:newSpell(Spell:Direct("Horn of Winter"))
	Watcher:newSpell(Spell:Buff(C["Horn of Winter"], "Horn of Winter"))
	Watcher:newSpell(Spell:Direct("Festering Strike"))
	Watcher:newSpell(Spell:Direct(C["Rune Strike"]))
	Watcher:newSpell(Spell:Direct("Empower Rune Weapon"))
	Watcher:newSpell(Spell:Direct("Frost Strike"))
	Watcher:newSpell(Spell:Buff(C["Lichborne"], "Lichborne"))
	Watcher:newSpell(Spell:Buff(C["Pillar of Frost"], "Pillar of Frost"))
	Watcher:newSpell(Spell:Debuff("Hungering Cold"))
	Watcher:newSpell(Spell:Direct("Howling Blast"))

	-- Unholy Spells and Talents
	Watcher:newSpell(Spell:Direct("Death Coil"))
	Watcher:newSpell(Spell:Proc(C["Sudden Doom"], "Death Coil"))
	Watcher:newSpell(Spell:PowerThresholdSpell(100, false, Spell:Direct("Death Coil")))
	Watcher:newSpell(Spell:Direct("Death Grip"))
	Watcher:newSpell(Spell:Apply(C["Blood Plague"], "Plague Strike"))
	Watcher:newSpell(Spell:Direct("Raise Dead"))
	Watcher:newSpell(Spell:Debuff("Death and Decay"))
	Watcher:newSpell(Spell:Buff(C["Anti-Magic Shell"], "Anti-Magic Shell"))
	Watcher:newSpell(Spell:Direct("Raise Ally"))
	Watcher:newSpell(Spell:Direct("Army of the Dead"))
	-- Watcher:newSpell(Spell:Apply(C["Blood Plague AND Frost Fever"]. "Outbreak")  Can't be implimented yet, requires tracking 2 debuffs.)
	Watcher:newSpell(Spell:Direct("Necrotic Strike"))
	Watcher:newSpell(Spell:Direct("Scourge Strike"))
	Watcher:newSpell(Spell:Buff(C["Unholy Frenzy"], "Unholy Frenzy"))
	Watcher:newSpell(Spell:Direct("Anti-Magic Zone"))
	Watcher:newSpell(Spell:Direct("Dark Transformation"))
	Watcher:newSpell(Spell:Direct("Summon Gargoyle"))
end