if not Watcher then return end
local _, _, _, clientVersion = GetBuildInfo()
if select(2, UnitClass('player')) ~= "HUNTER" then return end
local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants


-- C\[([^\]]+)\D+(\d+).+ regex for replacing C[] terms
Watcher:addicon("Beast Lore", 1462)
Watcher:addicon("Serpent Sting",1978)
Watcher:addicon("Explosive Shot",53301)
Watcher:addicon("Aimed Shot", 82928)
Watcher:addicon("Improved Steady Shot", 53224)
Watcher:addicon("Black Arrow",3674)
Watcher:addicon("Steady Shot",56641)

Watcher:addicon("Cobra Shot",77767)
Watcher:addicon("Multi-Shot",2643)
Watcher:addicon("Aspect of the Hawk",13165)
Watcher:addicon("Arcane Shot",3044)
Watcher:addicon("Hunter's Mark",1130)
Watcher:addicon("Kill Shot",53351)

Watcher:addicon("Lock and Load",56453)

Watcher:addicon("Chimera Shot",53209)

Watcher:addicon("Rapid Fire",3045)
Watcher:addicon("Bestial Wrath",19574)
Watcher:addicon("Blood Fury",20572)
Watcher:addicon("Readiness",23989)
Watcher:addicon("Kill Command",34026)
Watcher:addicon("Auto Shot",75)
Watcher:addicon("Silencing Shot",34490)
Watcher:addicon("Misdirection",34477)
Watcher:addicon("Fire!",82926)
function Watcher:addClassSpells()
Watcher:AimedShot()--
Watcher:CobraShot()--
Watcher:AH()--
--Watcher:Print(GetSpellInfo(56641))
Watcher:ExplosiveShot()--
--Watcher:BlackArrow()--
Watcher:KillCommand()--
Watcher:HM()--
Watcher:Misdirection()--

--Watcher:AVH()--
Watcher:ArcaneShot()--
Watcher:MultiShot()--
Watcher:SerpentSting()--
Watcher:SteadyShot()--
Watcher:ChimeraShot()
Watcher:KillShot()--
Watcher:SilencingShot()--
Watcher:RapidFire()--
Watcher:BloodFury()--
Watcher:BestialWrath()--
Watcher:Readiness()--
Watcher:newSpell(Spell:Buff("Improved Steady Shot", "Steady Shot"))
Watcher:newSpell(Spell:Direct("Black Arrow"))

end			


function Watcher:AimedShot()
	Watcher:newSpell(Spell:Proc(C["Fire!"],"Aimed Shot"))
	Watcher:newSpell(Spell:Direct("Aimed Shot"))
	--Watcher:Direct("Aimed Shot",nil, 100, true, 100, true)
end


--\[C\[(.+)\]\]
--Watcher:newSpell(def)  \n end
function Watcher:CobraShot()
	local def = {}
	local name = "Cobra Shot"
	def.spellName = C[name]
	def.name = C[name]
	def.icon =  C[name.." Icon"]
	def.stockspell = true	
	
Watcher:newSpell(def)  
end


function Watcher:ExplosiveShot()
	Watcher:newSpell(Spell:AddInternalCooldown(2, Spell:Direct("Explosive Shot")))

end

function Watcher:SerpentSting()
	local def = {}
	def.spellName = C["Serpent Sting"]
	def.name = C["Serpent Sting"]
	def.trackAura = true
	def.icon =  C["Serpent Sting Icon"]
	def.debuffs = C["Serpent Sting"]
	def.stockspell = true
	Watcher:newSpell(def)  
end

function Watcher:BlackArrow()
	local def = {}
	def.spellName = C["Black Arrow"]
	def.name = C["Black Arrow"]
	def.icon =  C["Black Arrow Icon"]
	def.stockspell = true
Watcher:newSpell(def)  
end
function Watcher:KillCommand()
	local def = {}
	def.spellName = C["Kill Command"]
	def.name = C["Kill Command"]
	def.icon =  C["Kill Command Icon"]
	def.stockspell = true
Watcher:newSpell(def)  
end

function Watcher:HM()
	local def = {}
	def.spellName = C["Hunter's Mark"]
	def.name = C["Hunter's Mark"]
	def.icon = C["Hunter's Mark Icon"]
	def.trackAura = true
	def.debuffs = C["Hunter's Mark"]
	def.stockspell = true
Watcher:newSpell(def)  
end

function Watcher:Misdirection()
	local def = {}
	def.spellName = C["Misdirection"]
	def.name = C["Misdirection"]

	def.icon =  C["Misdirection Icon"]
	def.stockspell = true
Watcher:newSpell(def)  
end

function Watcher:AH()
	local def = {}
	def.spellName = C["Aspect of the Hawk"]
	def.name = C["Aspect of the Hawk"]
	def.trackAura = true
	def.isbuff = true
	def.icon =  C["Aspect of the Hawk Icon"]
	def.buffs = C["Aspect of the Hawk"]
	def.noCD = true
	def.stockspell = true
Watcher:newSpell(def)  
end

function Watcher:ChimeraShot()
	local def = {}
	def.spellName = C["Chimera Shot"]
	def.name = C["Chimera Shot"]

	def.icon =  C["Chimera Shot Icon"]

	def.stockspell = true
Watcher:newSpell(def)  
end

function Watcher:ArcaneShot()
	Watcher:newSpell(Spell:Direct("Arcane Shot"))
	end


function Watcher:MultiShot()
	local def = {}
	def.spellName = C["Multi-Shot"]
	def.name = C["Multi-Shot"]
	def.trackAura = false
	def.typeshortdot = false
	def.dotlength = 0
	def.dottime = 0
	def.isbuff = false
	def.icon =  C["Multi-Shot Icon"]
	def.powerthresh = 0
	def.countreq = 0
	def.dotthreshold = 0
	def.combocost = 0
	def.trackspell = C["Multi-Shot"]
	def.nocd = false
	def.caster = false
	def.isproc = false
	def.negthreshold = false
	def.stockspell = true
Watcher:newSpell(def)  
end

function Watcher:SteadyShot()
	local def = {}
	def.spellName = C["Steady Shot"]
	def.name = C["Steady Shot"]
	def.trackAura = false
	def.typeshortdot = false
	def.dotlength = 0
	def.dottime = 0
	def.isbuff = false
	def.icon =  C["Steady Shot Icon"]
	def.powerthresh = 0
	def.countreq = 0
	def.dotthreshold = 0
	def.combocost = 0
	def.trackspell = C["Steady Shot"]
	def.nocd = false
	def.caster = false
	def.isproc = false
	def.negthreshold = false
	def.stockspell = true
Watcher:newSpell(def)  
end


function Watcher:KillShot()
	local def = {}
	def.spellName = C["Kill Shot"]
	def.name = C["Kill Shot"]
	def.trackAura = false
	def.typeshortdot = false
	def.dotlength = 0
	def.dottime = 0
	def.isbuff = false
	def.icon =  C["Kill Shot Icon"]
	def.powerthresh = 0
	def.countreq = 0
	def.dotthreshold = 0
	def.combocost = 0
	def.trackspell = nil
	def.nocd = false
	def.caster = false
	def.isproc = false
	def.negthreshold = false
	def.stockspell = true
Watcher:newSpell(def)  
end


function Watcher:Readiness()
	local def = {}
	--self:Print(C["Readiness"])
	def.spellName = C["Readiness"]
	def.name = C["Readiness"]
	def.trackAura = false
	def.typeshortdot = false
	def.dotlength = 0
	def.dottime = 0
	def.isbuff = false
	def.icon =  C["Readiness Icon"]
	def.powerthresh = 0
	def.countreq = 0
	def.dotthreshold = 0
	def.combocost = 0
	def.trackspell = C["Readiness"]
	def.nocd = false
	def.caster = false
	def.isproc = false
	def.negthreshold = false
	def.stockspell = true
Watcher:newSpell(def)  
end

function Watcher:SilencingShot()
	local def = {}
	def.spellName = C["Silencing Shot"]
	def.name = C["Silencing Shot"]
	def.trackAura = false
	def.typeshortdot = false
	def.dotlength = 0
	def.dottime = 0
	def.isbuff = false
	def.icon =  C["Silencing Shot Icon"]
	def.powerthresh = 0
	def.countreq = 0
	def.dotthreshold = 0
	def.combocost = 0
	def.trackspell = C["Silencing Shot"]
	def.nocd = false
	def.caster = false
	def.isproc = false
	def.negthreshold = false
	def.stockspell = true
Watcher:newSpell(def)  
end
function Watcher:RapidFire()
	local def = {}
	def.spellName = C["Rapid Fire"]
	def.name = C["Rapid Fire"]
	def.trackAura = false
	def.typeshortdot = false
	def.dotlength = 0
	def.dottime = 0
	def.isbuff = false
	def.icon =  C["Rapid Fire Icon"]
	def.powerthresh = 0
	def.countreq = 0
	def.dotthreshold = 0
	def.combocost = 0
	def.trackspell = C["Rapid Fire"]
	def.nocd = false
	def.caster = false
	def.isproc = false
	def.negthreshold = false
	def.stockspell = true
Watcher:newSpell(def)  
end
function Watcher:BloodFury()
	local def = {}
	def.spellName = C["Blood Fury"]
	def.name = C["Blood Fury"]
	def.trackAura = false
	def.typeshortdot = false
	def.dotlength = 0
	def.dottime = 0
	def.isbuff = false
	def.icon =  C["Blood Fury Icon"]
	def.powerthresh = 0
	def.countreq = 0
	def.dotthreshold = 0
	def.combocost = 0
	def.trackspell = C["Blood Fury"]
	def.nocd = false
	def.caster = false
	def.isproc = false
	def.negthreshold = false
	def.stockspell = true
Watcher:newSpell(def)  
end

function Watcher:BestialWrath()
	local def = {}
	def.spellName = C["Bestial Wrath"]
	def.name = C["Bestial Wrath"]

	def.icon =  C["Bestial Wrath Icon"]
	
	def.stockspell = true
Watcher:newSpell(def)  
end



Watcher.priorityTable.name["gcd"] = "GCD"
Watcher.priorityTable.icon["gcd"] = C["Beast Lore Icon"]
Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Beast Lore"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)
		end
	end 
	