local C = Watcher.constants
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")

Spell = {}
Spell.__index = Spell


function Spell:new(name, id) -- based on 
	local self = {}
	--- maybe add some check here to see if the name can be added if it's not part of the C table
	
	local spellname, icon
	--setmetatable(self, Spell)
	-- need to fix this
	if not C[name] then
		--local num = name
		tonumber(id)
		if id then
			spellname, _, icon = GetSpellInfo(id)
			if spellname then
				Watcher:addicon(spellname, id)
				--name = spellname
				if not name then
					name = spellname
				end
			else
				error("spell doesn't exist")
				return
			end
		elseif name then
			---- TODO
			spellname, _, icon = GetSpellInfo(name)
			if spellname then
				Watcher:addicon(spellname)
			else
				error("spell doesn't exist: "..name)
			end
			
		else
			error("spell doesn't exist: "..name)
		end
		
	end	
	
	self.name = C[name] or C[spellname]
	self.spellName = C[name] or C[spellname]
	self.spellID = id or nil
	self.icon = C[name.." Icon"]
	self.stockspell = true
	
	return self
end

function Spell:Direct(name)
	local self = {}
	self = Spell:new(name,C[name.." SID"])
	return self
end

function Spell:Debuff(name, casttime, stack)
	local self = {}
	self = Spell:new(name)
	self.trackspell = C[name]
	self.debuffs = C[name]
	self.typedot =  true -- true if looking for an aura (on caster or target)
	self.dotthreshold = casttime or 0
	self.countreq = stack or 0
	self.caster = true -- ignore other player's debuffs
	return self
end

function Spell:Buff(buff, name)
	local self = {}
	if not name then
		name = buff
	end
	self = Spell:new(name)
	self.trackspell = buff
	self.buffs = buff
	self.typedot =  true -- true if looking for an aura (on caster or target)
	self.isbuff =  true -- true if %trackspell is an aura on the caster
	self.dotthreshold = casttime or 0
	self.countreq = stack or 0
	if C[name] ~= C[buff] then
		self.name = C[name].." for "..C[buff]
	end
	return self
end


function Spell:BuffPerm(buff, name)
	local self = {}
	
	self = Spell:Buff(buff, name)
	self.noCD = true
	return self
end

function Spell:Proc(buff, name)
	local self = {}
	
	self = Spell:Buff(buff, name)
	if name == nil then
		name = buff
	end
	self.name =  C[name].." w/ "..C[buff]
	self.isproc =  true
	return self
end

function Spell:calcCost()
	self.cost = select(4, GetSpellInfo(self.spellID or self.spellName))

end

function Spell:Apply(debuff, name, casttime, stack, playercast)  --- Used when the debuffs name is seperate from spells name
	local self = {}
	self = Spell:Debuff(name, casttime, stack)
	self.caster = playercast or true
	self.name = name.." for "..debuff
	self.trackspell = debuff
	self.debuffs = debuff
	return self
end

function Spell:Capitalize(debuff, name)
	local self = {}
	self = Spell:Debuff(name)
	self.trackspell = debuff
	self.debuffs = debuff
	self.isproc = true
	self.name = C[name].." w/ "..C[debuff]
end

function Spell:HealhThresholdSpell(threshold, reverse, func)
	local self = {}
	if func then
		self = func
	else
		return
	end
	self.healthThreshold = threshold
	self.negHealthThreshold = reverse
	local _string = ""
	if reverse then
		_string = " @<=".. _string.."%health"
	else
		--if(health) then
		_string = " @>=".. threshold.."%health"
		--end
	end
	self.name = self.name.._string
	return self
end

function Spell:PowerThresholdSpell(threshold, reverse, func)
	local self = {}
	if func then
		self = func
	else
		return
	end
	self.powerThreshold = threshold
	self.negpowerThreshold = reverse
	local _string = ""
	if reverse then
		_string = " @<=".. _string.."%power"
	else
		--if(power) then
		_string = " @>=".. threshold.."%power"
		--end
	end
	self.name = self.name.._string
	return self
end

function Spell:ComboSpell(point,func)
	local self = {}
	if func then
		self = func
	else
		return
	end
	self.combocost = point
	local _string = ""
	if reverse then
		_string = "@"..point.."CP/HP"
	end
	self.name = self.name.._string
	return self
end


function Spell:AddInternalCooldown(cd, func)
	
	local self = {}
	if func then
		self = func
	else
		return
	end
	self.inCD = cd
	--Watcher:Print(cd, self.inCD)
	
	return self
end

function Spell:ThreatSpell(threshold, reverse, func)
	local self = {}
	if func then
		self = func
	else
		return
	end
	self.threatThreshold = threshold
	self.negThreatThreshold = reverse
	local _string = ""
	if reverse then
		_string = " @<=".. _string.."%threat"
	else
		--if(power) then
		_string = " @>=".. threshold.."%threat"
		--end
	end
	self.name = self.name.._string
	return self
	
end

function Spell:getName()
	return self.name
end

function Spell:FullCopyLeg(key)
	local def = Watcher.db.char.spell
	if(next(Watcher.db.class.spells)) then
		for k,v in pairs(Watcher.db.class.spells) do
			if Watcher.db.class.spells[k].name == def.name[key] then
				local s = "Spell already exists in table: "
				return s
			end
		end
	end
	local self = {}
	
	self = Spell:new(def.spellname[key],def.spellID[key])
	self.name = def.name[key] 
	self.spellName = def.spellname[key] 
	self.spellID = def.spellID[key]
	self.icon = def.icon[key]
	self.stockspell = def.stockspell[key]	
	self.typedot = def.typedot[key] 
	self.inCD = def.dotlength[key]
	self.isbuff = def.isbuff[key]
	self.powerThreshold = def.powerthresh[key]
	self.countreq = def.countreq[key]
	self.dotthreshold = def.dotthreshold[key]
	self.combocost = def.combocost[key]
	self.trackspell = def.trackspell[key]
	self.nocd = def.nocd[key]
	self.negpowerThreshold = def.negthreshold[key]
	self.caster = def.caster[key]
	self.caster = def.isproc[key]
	self.healthThreshold = def.healthThreshold[key]
	self.negHealthThreshold = def.negHealthThreshold[key]
	--[[self.buffs = def.buffs[key]
	self.buffs = def.debuffs[key]
	self.trackAura = def.trackAura[key]
	self.dct = def.dct[key]
	self.andAuras = def.andAuras[key]]
--	self:getName()
	--Watcher:Print(self:getName())
	return self
end

--[[
function Spell:FullCopy(key)
	local def = Watcher.db.class.spells[key]
	local self = {}
	--self = Spell:new(def.spellName,def.spellID)
	self.name = def.name 
	self.spellName = def.spellName 
	self.spellID = def.spellID
	self.icon = def.icon
	self.stockspell = def.stockspell	
	self.typedot = def.typedot 
	--def.typeshortdot
	self.inCD = def.inCD
	--def.dottime
	self.isbuff = def.isbuff
	self.powerThreshold = def.powerThreshold
	self.countreq = def.countreq
	self.dotthreshold = def.dotthreshold
	self.combocost = def.combocost
	self.trackspell = def.trackspell
	self.nocd = def.nocd
	self.negPowerThreshold = def.negPowerthreshold
	self.caster = def.caster
	self.caster = def.isproc
	self.healthThreshold = def.healthThreshold
	self.negHealthThreshold = def.negHealthThreshold
	self.buffs = def.buffs
	self.buffs = def.debuffs
	self.trackAura = def.trackAura
	self.dct = def.dct
	self.andAuras = def.andAuras
	return self
end
	]]
	
function Spell:makeSpell(self)
	setmetatable(self,Spell)
	return self
end	

function Spell:AddPriorityTable() -- add priority table based on spell's keymk
	Watcher.priorityTable.name[self.name] = self.name
	Watcher.priorityTable.icon[self.name] = self.icon
	Watcher.priorityTable.check[self.name] = function (FrameName, optionnum)
	self:UpdateSpell(FrameName, optionnum) 
	end
end

function Spell:RemovePriorityTable()
	Watcher.priorityTable.name[self.name] = nil
	Watcher.priorityTable.icon[self.name] = nil
	Watcher.priorityTable.check[self.name] = nil
end
