if not Watcher then return end
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local C = Watcher.constants

Watcher.debuffs = {}
Watcher.buffs = {}

local spells

--[[
	Still need to sort out how to handle stack count for multiple spell tracking 
		- either count on all auras or only on first
	
]]

-- takes spells from option file and adds them to the priority table
function Watcher:AddSpells()	
	Watcher:AddClassBehaviour()
	Watcher:shortDots()
	--Watcher:legacyAuras()
	Watcher:setAuras()
	
	
end
	
-- add auras from old dot system to the new version
function Watcher:legacyAuras()
	local spell = self.db.class.spells
	for k,v in pairs(spell) do
		if spell[k].typedot then
			spell[k].trackAura = spell[k].typedot
			if spell[k].isbuff then
				spell[k].buffs = spell[k].trackspell
			else
				spell[k].debuffs = spell[k].trackspell
			end
		end
	end
end
	
-- This only really applies to Explosive Shot which has a dot which is too short to really track using the usual method
function Watcher:shortDots()
	local spell = self.db.class.spells
	for k,v in pairs (spell) do
		if spell[k].inCD then
		--	self:Print(spell[k].name, spell[k].spellName)
			Watcher.dottime[spell[k].name] = GetTime() + spell[k].inCD
		end
	end
end

function Watcher:setAuras()
	local spell = self.db.class.spells
	for k,v in pairs(spell) do
		if spell[k].trackAura then
			if spell[k].buffs then 
				Watcher:getBuffs(spell[k])
			end
			if spell[k].debuffs then 			
				Watcher:getDebuffs(spell[k])
			end
		end
	end
end

function Watcher:getBuffs(spell)
	Watcher.buffs[spell.name] = Watcher:splitField(spell.buffs)
end

function Watcher:getDebuffs(spell)
	Watcher.debuffs[spell.name] = Watcher:splitField(spell.debuffs)
end

function Watcher:classFromLegacy()
	
	for k,v in pairs(self.db.char.spell.name) do
		local spell = Spell:FullCopyLeg(k)
	--	self:Print(v, spell.name)
		if type(spell) == "string" then
		--	self:Print(spell..v)
		else
			Watcher:addSpellToTable(spell)
		end
	end
end

function Watcher:addSpellToTable(spell)
	local t = self.db.class.spells
	spell.stockspell = false
	table.insert(t, spell)
	
end

function Watcher:newSpell(f) --- spell function
	local t = Watcher.defaults.class.spells
	table.insert(t, f)
end

function Watcher:addSpell(spell)
	self:newSpell(spell)
end

function Watcher:AddClassBehaviour()
	local spells = self.db.class.spells
	
	for k,v in pairs(spells) do		
		spells[k] = Spell:makeSpell(spells[k])--Spell:FullCopy(k)
		--spells[k]:AddPriorityTable()
	end
	
end


function Watcher:returnNames(t)
	local tab = {}
	for k,v in pairs(t) do
		tab[t[k].name]= t[k].name
	end
	tab["none"] = "None"
	tab["none"] = "None"
	return tab
end

function Watcher:AddAllPriorityTable()
	for k,v in pairs(self.db.class.spells) do
		spells[k]:AddPriorityTable()
	end
end

function Watcher:addicon(spellname, spellID)
	C[spellname], _, C[spellname.." Icon"] = GetSpellInfo(spellID)
	C[spellname.." SID"] = spellID
end

function Watcher:returnSpellByName(name)
	local spells = self.db.class.spells
	for k,v in pairs(spells)do
		if spells[k].name == name then
			return spells[k]
		end
	end
	error("spell not found ".. name)
end


